#if defined _StockRP_included
 #endinput
#endif
#define _StockRP_included

//Variable:
static Float:GameTime[MAXPLAYERS + 1] = {0.0,...};
static ClientFrom;

forward Action:OnClientTeam(Handle:Event, Client, NewTeam, OldTeam);

forward Action:OnClientSpawn(Client);

forward Action:OnClientActivate(Client);

forward Action:OnClientName(Client, String:NewName[32], String:OldName[32]);

forward Action:OnClientChat(Client, Bool:IsTeamOnly, const String:Text[], maxlength);

forward Action:OnClientDied(Client, Attacker, const String:ClientWeapon[32], const String:PlayerWeapon[32], bool:headshot);

stock HideHud(Client, Type)
{

	//Set Prop Data:
	SetEntProp(Client, Prop_Send, "m_iHideHUD", Type);
}

stock SetEntityArmor(Client, Armor)
{

	//Initialize:
	SetEntProp(Client, Prop_Data, "m_ArmorValue", Armor, 4);
}

stock GetClientScore(Client)
{

	//Return:
	return GetEntProp(Client, Prop_Data, "m_iFrags");
}

stock SetClientScore(Client, score)
{

	//Set Prop Data:
	SetEntProp(Client, Prop_Data, "m_iFrags", score);
}

stock SetClientDeath(Client, death)
{

	//Set Prop Data:
	SetEntProp(Client, Prop_Data, "m_iDeaths", death); 
}

stock SetEntitySpeed(Client, Float:fSpeed)
{

	//Set Prop Data:
	SetEntPropFloat(Client, Prop_Data, "m_flLaggedMovementValue", fSpeed);	
}

stock GetClientTeamEx(Client)
{

	//Get Client Team:
	new m_iTeamNum = FindSendPropOffs("CBasePlayer", "m_iTeamNum");

	//Return:
	return m_iTeamNum;
}

stock ChangeClientTeamEx(Client, Team)
{

	//Get Client Team:
	new m_iTeamNum = FindSendPropOffs("CBasePlayer", "m_iTeamNum");

	//Set Prop Data:
	SetEntData(Client, m_iTeamNum, Team);
}

//Bipass Cheats:
stock CheatCommand(Client, const String:command[], const String:arguments[])
{

	//Connected:
	if(IsClientConnected(Client) && IsClientInGame(Client))
	{

		//Define:
		new admindata = GetUserFlagBits(Client);

		//Set Client Flag Bits:
		SetUserFlagBits(Client, ADMFLAG_ROOT);

		//Define:
		new flags = GetCommandFlags(command);

		//Set Client Flags:
		SetCommandFlags(command, flags & ~FCVAR_CHEAT);

		//Command:
		ClientCommand(Client, "\"%s\" \"%s\"", command, arguments);

		//Set Client Flags:
		SetCommandFlags(command, flags);

		//Set Client Flag Bits:
		SetUserFlagBits(Client, admindata);
	}

	//Return:
	return;
}

stock OverflowMessage(Client, const String:Contents[255])
{

	//Is In Time:
	if(GameTime[Client] <= (GetGameTime() - 7))
	{

		//Print:
		CPrintToChat(Client, Contents);

		//Initialize:
		GameTime[Client] = GetGameTime();
	}
}

stock bool:intTobool(i)
{

	if(i == 1) return true;
	else return false;
}

stock boolToint(bool:i)
{

	if(i) return 1;
	else return 0;
}

public bool:TraceEntityFilterEntity(entity, contentsMask)
{
	return entity > 0 && entity != ClientFrom;
}

public bool:TraceEntityFilterWall(entity, contentsMask)
{
	return !entity;
}

stock bool:LookingAtWall(Client)
{

	//Declare:
	decl Float:Origin[3], Float:Angles[3], Float:EndPos[3];

	//Initialize:
	GetClientEyePosition(Client, Origin);

	GetClientEyeAngles(Client, Angles);

	decl Float:dist1;
	dist1 = 0.0;
	decl Float:dist2;
	dist2 = 0.0;

	ClientFrom = Client;

	//Handle:
	new Handle:Trace1 = TR_TraceRayFilterEx(Origin, Angles, MASK_SHOT, RayType_Infinite, TraceEntityFilterEntity);

	//Is Tracer
	if(TR_DidHit(Trace1))
	{
		TR_GetEndPosition(EndPos, Trace1);

			//Initialize:
		dist1 = GetVectorDistance(Origin, EndPos);
	}
	else
	{
		dist1 = -1.0;
	}

	//Close:
	CloseHandle(Trace1);

	//Handle:
	new Handle:Trace2 = TR_TraceRayFilterEx(Origin, Angles, MASK_SHOT, RayType_Infinite, TraceEntityFilterWall);
   	 	
	//Is Tracer
	if(TR_DidHit(Trace2))
	{
		TR_GetEndPosition(EndPos, Trace2);

		//Initialize:
		dist2 = GetVectorDistance(Origin, EndPos);
	}

	//Override:
	else
	{

		//Initialize:
		dist2 = -1.0;
	}

	//Close:
	CloseHandle(Trace2);

	ClientFrom = -1;

	//Initialize:
	if(dist1 >= dist2)
	{

		//Return:
		return true;
	}

	//Return:
	return false;
}

stock bool:IsAdmin(client)
{

	//Declare:
	new AdminId:adminId = GetUserAdmin(client);

	//Is Valid Admin:
	if (adminId == INVALID_ADMIN_ID)
	{

		//Return:
		return false;
	}

	//Return:
	return GetAdminFlag(adminId, Admin_Generic);
}

stock bool:IsInDistance(Ent1, Ent2)
{

	//Declare:
	decl Float:ClientOrigin[3], Float:EntOrigin[3];

	//Initialize:
	GetEntPropVector(Ent1, Prop_Send, "m_vecOrigin", ClientOrigin);

	GetEntPropVector(Ent2, Prop_Send, "m_vecOrigin", EntOrigin);

	//Declare:
	new Float:Dist = GetVectorDistance(ClientOrigin, EntOrigin);

	//In Distance:
	if(Dist <= 150)
	{

		//Return:
		return true;
	}

	//Return:
	return false;
}

stock bool:CheckRobDistance(Client, Ent, Float:Origin[3])
{

	//Declare:
	decl Float:ClientOrigin[3], Float:EntOrigin[3];

	//Initialize:
	GetClientAbsOrigin(Client, ClientOrigin);

	GetEntPropVector(Ent, Prop_Send, "m_vecOrigin", EntOrigin);

	//Declare:
	new Float:Dist = GetVectorDistance(ClientOrigin, EntOrigin);

	//In Distance:
	if(Dist <= 150 && Origin[0] > EntOrigin[0] - 5.0 && Origin[0] < EntOrigin[0] + 5.0 && Origin[1] > EntOrigin[1] - 5.0 && Origin[1] < EntOrigin[1] + 5.0 && Origin[2] > EntOrigin[2] - 5.0 && Origin[2] < EntOrigin[2] + 5.0)
	{

		//Return:
		return true;
	}

	//Return:
	return false;
}

stock iCreateMenu(Client, MenuHandler:MenuForward, String:title[], String:info[20][], String:display[20][], pagination)
{

	//Handle:
	new Handle:Menu = CreateMenu(MenuForward);

	//Menu Title:
	SetMenuTitle(Menu, title);

	//Loop:
	for(new X = 0; X < 15; X++) if(strlen(display[X]) > 0)
	{

		//Menu Button:
		AddMenuItem(Menu, info[X], display[X]);
	}

	if(pagination != 0)
	{

		//Max Menu Buttons:
		SetMenuPagination(Menu, pagination);
	}

	//Set Exit Button:
	SetMenuExitButton(Menu, false);

	//Show Menu:
	DisplayMenu(Menu, Client, 30);
}

stock PrintEscapeText(Client, String:text[1024], any:...)
{

	//Declare:
	decl String:message[1024];

	//Format:
	VFormat(message, sizeof(message), text, 3);

	//Handle:
	new Handle:kv = CreateKeyValues("Message", "Title", message);

	//Set Color:
	KvSetColor(kv, "color", 50, 250, 50, 255);

	//Set Number:
	KvSetNum(kv, "level", 1);

	//Set Float:
	KvSetFloat(kv, "time", 1.5);

	//Show Menu:
	CreateDialog(Client, kv, DialogType_Text);

	//Close:
	CloseHandle(kv);
}