
//Includes:
#include <colors>

//Terminate:
#pragma semicolon		1
#pragma compress		0

//Definitions:
#define PLUGINVERSION		"1.03.24"

//Roleplay Core:
static String:ServerMap[64];

//Plugin Info:
public Plugin:myinfo =
{
	name = "Official Roleplay Crash Check",
	author = "Master(D)",
	description = "Exension for the Roleplay Main Plugin (Lite)",
	version = PLUGINVERSION,
	url = ""
};

//Initation:
public OnPluginStart()
{

	//Declare:
	decl String:GameName[32];

	//Initialize:
	GetGameFolderName(GameName, sizeof(GameName));

	//Not Map:
	if(!StrEqual(GameName, "hl2mp"))
	{

		//Fail State:
		SetFailState("|RolePlay| This Plugin Only Sopports 'HL2DM' And 'Official Roleplay Mod Core'");
	}

	//Print Server If Plugin Start:
	PrintToConsole(0, "|RolePlay| Crash Check Successfully Loaded (v%s)!", PLUGINVERSION);

	//Timer:
	CreateTimer(30.0, CheckPluginStatus, _, TIMER_REPEAT);

	//Create Auto Configurate File:
	AutoExecConfig(true, "MS_Roleplay_AutoExec");

	//Server Version:
	CreateConVar("sm_roleplay_version_crashcheck", PLUGINVERSION, "show the version of the roleplaying mod", FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_UNLOGGED|FCVAR_DONTRECORD|FCVAR_REPLICATED|FCVAR_NOTIFY);
}

//Is Extension Loaded:
public APLRes:AskPluginLoad2(Handle:myself, bool:late, String:error[], err_max)
{

	//Declare:
	decl String:Map[128];

	//Initialize:
	GetCurrentMap(Map, 128);

	//Is Roleplay Map:
	if(StrContains(Map, "rp_", false) != -1)
	{

		//Return:
		return APLRes_Success;
	}

	//Format:
	Format(error, err_max, "|Roleplay| this only can run on roleplay maps.");

	//Close:
	CloseHandle(myself);

	//Return:
	return APLRes_SilentFailure;
}

//Map Start:
public OnMapStart()
{

	//Initialize:
	GetCurrentMap(ServerMap, sizeof(ServerMap));
}

public Action:CheckPluginStatus(Handle:Timer)
{

	//Handle:
	new Handle:PFind = FindPluginByFile("rp_Core_Classic.smx");

	//Find:
	if(PFind != INVALID_HANDLE) 
	{

		//Plugin Status:
		if(GetPluginStatus(PFind) != Plugin_Running)
		{

			//Command:
			AutoModRestarter();
		}
	}

	//Override:
	else
	{

		//Command:
		AutoModRestarter();
	}
}

public Action:ChangeMap(Handle:Timer)
{

	//Command:
	ServerCommand("changelevel \"%s\"", ServerMap);
}

AutoModRestarter()
{

	//Timer:
	CreateTimer(5.0, ChangeMap, _, TIMER_REPEAT);

	//Print:
	CPrintToChatAll("{red}|RP|\x01 - It has seemed that the roleplay mod has crashed. \nThe server will restart in 5.0 seconds.");
}
