#include <sdktools>
#include <sdkhooks>

//Definitions:
#define PLUGINVERSION		"2.24.36"

//Declare:
static String:ServerMap[255];

//Information:
public Plugin:myinfo =
{

	//Initation:
	name = "Official Map Crash Preventer",
	author = "Master(D)",
	description = "deletes all harmfull entitys in the map",
	version = PLUGINVERSION,
	url = ""
}

//Initation:
public OnPluginStart()
{

	//Print Server If Plugin Start:
	PrintToConsole(0, "|RolePlay| Map Crash Preventer Successfully Loaded (v%s)!", PLUGINVERSION);
}

//Map Start:
public OnMapStart()
{

	//Hook Entity Output:
	HookEntityOutput("game_end", "EndGame",EntityOutput);

	HookEntityOutput("point_servercommand","Command",EntityOutput);

	HookEntityOutput("point_clientcommand","Command",EntityOutput);

	//Initialize:
	GetCurrentMap(ServerMap, sizeof(ServerMap));

	if(StrEqual(ServerMap, "RP_City8_OutCast_MS"))
	{

		//Command:
		ServerCommand("sv_cheats 1");

		ServerCommand("ent_remove_all respawn");

		ServerCommand("ent_remove_all electichurt");

		ServerCommand("sv_cheats 0");

		//Print:
		PrintToServer("|RolePlay| Found Bad Entities (Removed).");
	}

	if(StrEqual(ServerMap, "rp_downtown_sp3a"))
	{

		//Command:
		ServerCommand("sv_cheats 1");

		ServerCommand("ent_remove_all yupthisisboring");

		ServerCommand("sv_cheats 0");

		//Print:
		PrintToServer("|RolePlay| Found Bad Entities (Removed).");
	}

	//Remove
	Perf_Erase();

}

public EntityOutput(const String:output[], Caller, Activator, Float:delay)
{

	new Count = 0;

	//Is Valid Entity:
	if(IsValidEntity(Caller))
	{

		if(IsValidEntity(Caller))
		{

			//Remove:
			RemoveEdict(Caller);

			//Initulize:
			Count++;
		}

		//Remove:
		RemoveEdict(Activator);
	}

	if(Count != 0)
	{

		//Print:
		PrintToServer("|RolePlay| Found Bad Entities (Removed)");
	}

	//Return:
	return true;
}

public Perf_Erase()
{

	//Declare:
	decl String:Class[128];

	new Count = 0;

	//Loop:
	for(new Ent = 0; Ent < 4096; Ent++)
	{

		//Is Entity:
		if(IsValidEdict(Ent))
		{

			//Get Class Name Of All Entitys:
			GetEdictClassname(Ent, Class, sizeof(Class));

			//Is Harmfull Entity:
			if((StrEqual(Class, "game_end", false) || StrEqual(Class, "point_clientcommand", false) || StrEqual(Class, "point_servercommand", false) || StrEqual(Class, "trigger_remove", false) || StrEqual(Class, "trigger_once", false)) || (StrEqual(Class, "func_tracktrain", false) && StrEqual(ServerMap, "rp_freemancity_kbm_public_v1")))
			{

				//Remove Entity:
				AcceptEntityInput(Ent, "kill");

				//Initulize:
				Count++;
			}
		}
	}

	if(Count != 0)
	{

		//Print:
		PrintToServer("|RolePlay| Found Bad Entities (Removed).");
	}

	if(Count == 0)
	{

		//Print:
		PrintToServer("|RolePlay| No Bad Entities Found.");
	}
}

public OnEntityCreated(entity, const String:classname[])
{

}

public Action:OnLevelInit(const String:mapName[], String:mapEntities[2097152])
{

	//Is Map:
	if(StrEqual(mapName, "rp_downtown_sp3a") || StrEqual(mapName, "rp_downtown_sp4a"))
	{

		//Replace:
		ReplaceString(mapEntities, sizeof(mapEntities), "vworldspawn", "worldspawn");

		//Declare:
		decl String:Class[128];

		//Loop:
		for(new Ent = 0; Ent < 4096; Ent++)
		{

			//Is Entity:
			if(IsValidEdict(Ent))
			{

				//Get Class Name Of All Entitys:
				GetEdictClassname(Ent, Class, sizeof(Class));

				//Is Harmfull Entity:
				if(StrEqual(Class, "vworldspawn", false))
				{

					//Ent:
					SetEntPropString(Ent, Prop_Data, "m_iClassname", "worldspawn")
				}
			}
		}

		//Return:
		return Plugin_Changed;
	}

	//Return:
	return Plugin_Continue;
}